﻿
Public Class Form1

    Private urlGlobalConfirmed As String = "https://raw.githubusercontent.com/CSSEGISandData/COVID-19/master/csse_covid_19_data/csse_covid_19_time_series/time_series_covid19_confirmed_global.csv"
    Private urlGlobalDeaths As String = "https://raw.githubusercontent.com/CSSEGISandData/COVID-19/master/csse_covid_19_data/csse_covid_19_time_series/time_series_covid19_deaths_global.csv"
    Private urlGlobalRecovered As String = "https://raw.githubusercontent.com/CSSEGISandData/COVID-19/master/csse_covid_19_data/csse_covid_19_time_series/time_series_covid19_recovered_global.csv"
    '
    Private urlItalia As String = "https://raw.githubusercontent.com/pcm-dpc/COVID-19/master/dati-andamento-nazionale/dpc-covid19-ita-andamento-nazionale.csv"
    Private urlItaliaRegioni As String = "https://raw.githubusercontent.com/pcm-dpc/COVID-19/master/dati-regioni/dpc-covid19-ita-regioni.csv"
    Private urlItaliaProvince As String = "https://raw.githubusercontent.com/pcm-dpc/COVID-19/master/dati-province/dpc-covid19-ita-province.csv"
    '
    Private StrRawDataConfirmed As String
    Private StrRawDataDeaths As String
    Private StrRawDataRecovered As String
    '
    Private StrRawDataItalia As String
    Private StrRawDataRegioni As String
    Private StrRawDataProvince As String
    '
    Private LinesGlobalConfirmed() As String
    Private LinesGlobalDeaths() As String
    Private LinesGlobalRecovered() As String
    '
    Private NationLinesConfirmedSorted As List(Of String)
    Private NationLinesDeathsSorted As List(Of String)
    '
    Private LinesItalia() As String
    Private LinesRegioni() As String
    Private LinesProvince() As String
    '
    Friend SelectedDataOrigin As DataOrigin
    Friend SelectedRegion As String
    Friend SelectedProvincia As String
    Friend SelectedDataType As String

    Friend Enum DataOrigin
        Nations
        Confirmed_and_Deaths
        Confirmed_and_Incr
        Deaths_and_Increments
        Italia
        Regioni
        Province
        Casi_e_Decessi
        Casi_e_Incrementi
        Decessi_e_Incrementi
    End Enum

    Friend Sub Combo_InitFromEnum(ByVal combo As ComboBox, ByVal enumType As Type)
        '                                                     use GetType(enum)
        combo.Items.Clear()
        For Each s As String In [Enum].GetNames(enumType)
            combo.Items.Add(s.Replace("_", " "))
        Next
    End Sub


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        SplitContainer1.Visible = False
        HideControls()
        ProgressBar1.Left = cmb_DataOrigin.Left
        ProgressBar1.Top = cmb_DataOrigin.Top
        ProgressBar1.Width = Me.ClientSize.Width - 24
        '
        Me.Text = AppTitleAndVersion()
        Combo_InitFromEnum(cmb_DataOrigin, GetType(DataOrigin))
        Load_INI()
        RedimDataArrayMax(10000)
        GraphPaper1.PB_TimeGraph = pbox_Graph
        Chart1.PB_ChartGraph = pbox_Graph
        '
        Refresh()
        Opacity = 1
        LoadRawData()
        LoadData()
        LoadPopulationData()
        ProgressBar1.Hide()
        ShowHideControls()
        SplitContainer1.Visible = True
        DecodeData()
        Timer1.Interval = 30
        Timer1.Start()
        EventsAreEnabled = True
    End Sub

    ' =====================================================================================
    '  Set Zoom with the Mouse Wheel
    ' =====================================================================================
    Private Sub pbox_TimeGraph_MouseWheel(ByVal sender As Object, _
                                          ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_Graph.MouseWheel
        If DataTypeIsChart() Then
            ChangeChartDay(CorrectMicrometricMouse(e.Delta))
        Else
            GraphPaper1.UpdateScalesWithMouseWheel(e.X, e.Y, CorrectMicrometricMouse(e.Delta))
        End If
        TimeGraphRefreshFlag = True
    End Sub
    Friend Function CorrectMicrometricMouse(ByVal Delta As Int32) As Int32
        Static sum As Int32 = 0
        sum += Delta
        If Math.Abs(sum) < 120 Then Return 0
        CorrectMicrometricMouse = sum \ 120
        sum = 0
    End Function

    ' ====================================================================================================
    '  Set DeltaSamples with MouseDown and MouseMove on the pbox_Graph
    ' ====================================================================================================
    Private oldx As Int32
    Private oldy As Int32
    Private startx As Int32
    Private starty As Int32
    Private LeftButtonPressed As Boolean
    Private Sub pbox_Graph_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_Graph.MouseDown
        '
        startx = e.X
        starty = e.Y
        oldx = e.X
        oldy = e.Y
        If e.Button = MouseButtons.Left Then
            LeftButtonPressed = True
        End If
        '
        If DataTypeIsChart() Then
            If e.Button = Windows.Forms.MouseButtons.Right Then
                MenuStrip1.Show(pbox_Graph, New Point(e.X, e.Y))
            Else
                Chart1.MouseDown(e)
            End If
        End If
    End Sub
    Private Sub pbox_Graph_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_Graph.MouseMove
        If e.Button = MouseButtons.Left Then
            If LeftButtonPressed Then
                Dim deltaX As Int32 = e.X - oldx
                Dim deltaY As Int32 = e.Y - oldy
                If My.Computer.Keyboard.ShiftKeyDown Then deltaX *= 100
                If My.Computer.Keyboard.CtrlKeyDown Then deltaX *= 10
                If DataTypeIsChart() Then
                    ChangeChartDay(deltaX * 0.1F)
                Else
                    GraphPaper1.UpdateWithMousePressed(deltaX, deltaY, startx, starty)
                End If
                oldx = e.X
                oldy = e.Y
                TimeGraphRefreshFlag = True
            End If
        Else
            If DataTypeIsChart() Then
                Chart1.MouseMove(e)
            End If
        End If
    End Sub
    Private Sub pbox_Graph_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_Graph.MouseUp
        LeftButtonPressed = False
    End Sub

    ' ====================================================================================================
    '  MenuStrip execution
    ' ====================================================================================================
    Friend DisabledNations As List(Of String) = New List(Of String)
    Friend DisabledItalianRegions As List(Of String) = New List(Of String)

    Private SelectedRegName As String = ""

    Private Sub MenuStrip1_HideSelectedNation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip1_HideSelectedNation.Click
        If SelectedRegName <> "" Then
            If DataOriginIsCharNations() Then
                DisabledNations.Add(SelectedRegName)
            Else
                DisabledItalianRegions.Add(SelectedRegName)
            End If
            Chart1.DeselectRegion()
            DecodeData()
        End If
    End Sub
    Private Sub MenuStrip1_ShowAllNations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip1_ShowAllNations.Click
        If DataOriginIsCharNations() Then
            DisabledNations.Clear()
        Else
            DisabledItalianRegions.Clear()
        End If
        DecodeData()
    End Sub
    Private Sub MenuStrip1_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MenuStrip1.Opening
        '
        If Chart1.LockedRegion Then
            SelectedRegName = Chart1.SelectedRegion
        Else
            Dim itm As ChartArray.Item = Chart1.GetItemByXY(startx, starty)
            SelectedRegName = itm.RegionName
        End If
        MenuStrip1_HideSelectedNation.Enabled = SelectedRegName <> ""
        '
        If DataOriginIsCharNations() Then
            MenuStrip1_HideSelectedNation.Text = "Disable the selected nation"
            MenuStrip1_ShowAllNations.Text = "Enable all the nations"
            MenuStrip1_ShowAllNations.Enabled = DisabledNations.Count > 0
        Else
            MenuStrip1_HideSelectedNation.Text = "Disabilita la regione selezionata"
            MenuStrip1_ShowAllNations.Text = "Abilita tutte le regioni"
            MenuStrip1_ShowAllNations.Enabled = DisabledItalianRegions.Count > 0
        End If
    End Sub

    ' ====================================================================================================
    '  Change Chart Nation-number
    ' ====================================================================================================
    Private Sub numeric_NumNations_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numeric_NumNations.ValueChanged
        If Not EventsAreEnabled Then Return
        DecodeChartNations(True)
    End Sub

    ' ====================================================================================================
    '  Change ChartDay
    ' ====================================================================================================
    Private ChartDay As Single = 0
    Private ChartDayInteger As Int32 = 0
    Private Sub ChangeChartDay(ByVal Delta As Single)
        ChartDay += Delta
        'If ChartDay < -60 Then ChartDay = -60
        If ChartDay > 0 Then ChartDay = 0
        ChartDayInteger = CInt(ChartDay)
        DecodeData(False)
    End Sub


    ' ====================================================================================================
    '  SET GRAPH POSITION - CLICKING ON TEXT OR USING KEY-UP AND KEY-DOWN
    ' ====================================================================================================
    Private Sub TextBox1_KeyDownUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) _
                                                                                    Handles txt_DataList.KeyDown, _
                                                                                            txt_DataList.KeyUp
        If e.KeyCode = Keys.Up Or e.KeyCode = Keys.Down Then
            Dim n As Int32 = txt_DataList.GetLineFromCharIndex(txt_DataList.SelectionStart)
            DecodeDateAndMoveGraphPaper(n)
        End If
    End Sub

    Private Sub txt_DataList_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_DataList.Click
        Dim n As Int32 = txt_DataList.GetLineFromCharIndex(txt_DataList.SelectionStart)
        DecodeDateAndMoveGraphPaper(n)
    End Sub

    Private Sub DecodeDateAndMoveGraphPaper(ByVal nline As Int32)
        Dim d As DateTime
        If nline >= txt_DataList.Lines.Length Then Return
        d = ParseDateFromString(txt_DataList.Lines(nline))
        'Form1.Text = d.ToString
        If d <> Date.MinValue Then
            GraphPaper1.ShowTimePoint(d)
        End If
    End Sub

    Private Function ParseDateFromString(ByVal s As String) As DateTime
        Dim d As DateTime
        Dim res As Boolean
        s = s.Replace("-", "/")
        s = s.Trim
        s = Strings.Left(s, 10)
        res = DateTime.TryParseExact(s, "yyyy/MM/dd", Nothing, Nothing, d)
        Return d
    End Function

    ' ====================================================================================================
    '  LOAD RAW DATA
    ' ====================================================================================================
    Private Sub LoadRawData()
        For i As Int32 = 1 To 5
            ProgressBar1.Parent = Me
            ProgressBar1.Value = 0
            StrRawDataConfirmed = DownloadStringFromURL(urlGlobalConfirmed)
            ProgressBar1.Value = 20
            StrRawDataDeaths = DownloadStringFromURL(urlGlobalDeaths)
            ProgressBar1.Value = 40
            StrRawDataRecovered = DownloadStringFromURL(urlGlobalRecovered)
            '
            ProgressBar1.Value = 50
            StrRawDataItalia = DownloadStringFromURL(urlItalia)
            ProgressBar1.Value = 60
            StrRawDataRegioni = DownloadStringFromURL(urlItaliaRegioni)
            ProgressBar1.Value = 70
            StrRawDataProvince = DownloadStringFromURL(urlItaliaProvince)
            ProgressBar1.Value = 90

            If i = 5 Then
                If MessageBox.Show("Could not load all the data files, retry ?", _
                                   "Message from Theremino Covid19", _
                                   MessageBoxButtons.YesNo, _
                                   MessageBoxIcon.Warning) = Windows.Forms.DialogResult.Yes Then
                    i = 1
                    Continue For
                Else
                    Exit For
                End If
            End If
            '
            If StrRawDataConfirmed = "" Then Continue For
            If StrRawDataDeaths = "" Then Continue For
            If StrRawDataRecovered = "" Then Continue For
            If StrRawDataItalia = "" Then Continue For
            If StrRawDataRegioni = "" Then Continue For
            If StrRawDataProvince = "" Then Continue For
            '
            Exit For
        Next
        '
        LinesGlobalConfirmed = Split(StrRawDataConfirmed, vbCrLf)
        LinesGlobalDeaths = Split(StrRawDataDeaths, vbCrLf)
        LinesGlobalRecovered = Split(StrRawDataRecovered, vbCrLf)
        ProgressBar1.Value = 93
        '
        LinesItalia = Split(StrRawDataItalia, vbCrLf)
        LinesRegioni = Split(StrRawDataRegioni, vbCrLf)
        LinesProvince = Split(StrRawDataProvince, vbCrLf)
        ProgressBar1.Value = 97
        '
        SortNationLines(LinesGlobalConfirmed)
        SumNationData(LinesGlobalConfirmed)
        '
        SortNationLines(LinesGlobalDeaths)
        SumNationData(LinesGlobalDeaths)
        '
        SortNationLines(LinesGlobalRecovered)
        SumNationData(LinesGlobalRecovered)
        '
        ' ---------------------------------------------------------------- get nation lines sorted by confirmed cases
        NationLinesConfirmedSorted = GetNationLinesSorted(LinesGlobalConfirmed)
        ' ---------------------------------------------------------------- get nation lines sorted by deaths cases
        NationLinesDeathsSorted = GetNationLinesSorted(LinesGlobalDeaths)
        '
        ProgressBar1.Value = 100
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If TimeGraphRefreshFlag Then
            TimeGraphRefreshFlag = False
            If DataTypeIsChart() Then
                Chart1.UpdateChart()
            Else
                GraphPaper1.UpdateTimeGraph()
            End If
        End If
    End Sub

    Private Sub chk_LockScales_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_LockScales.CheckedChanged
        TimeGraphRefreshFlag = True
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
    End Sub

    Private Sub gbox_Graph_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles gbox_Graph.Resize
        If Not EventsAreEnabled Then Return
        TimeGraphRefreshFlag = True
    End Sub

    Private Sub chk_OriginalData_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_OriginalData.CheckedChanged
        If Not EventsAreEnabled Then Return
        ShowHideControls()
        LoadData()
        DecodeData()
    End Sub

    Private Sub HideControls()
        cmb_DataOrigin.Visible = False
        cmb_Regions.Visible = False
        cmb_Province.Visible = False
        cmb_DataType.Visible = False
    End Sub

    Private Sub ShowHideControls()
        cmb_DataOrigin.Visible = True
        If DataTypeIsChart() Then
            If DataOriginIsCharNations Then
                numeric_NumNations.Parent = Me
                lbl_NumNations.Parent = Me
                lbl_NumNations.ForeColor = Color.FromArgb(80, 80, 80)
                lbl_NumNations.Top = cmb_DataType.Top + 4
                numeric_NumNations.Top = cmb_DataType.Top
                lbl_NumNations.Left = cmb_DataOrigin.Right + 22
                numeric_NumNations.Left = lbl_NumNations.Right + 2
                lbl_NumNations.Visible = True
                numeric_NumNations.Visible = True
            Else
                lbl_NumNations.Visible = False
                numeric_NumNations.Visible = False
            End If
            cmb_Regions.Visible = False
            cmb_Province.Visible = False
            cmb_DataType.Visible = False
            chk_LockScales.Visible = True
        Else
            lbl_NumNations.Visible = False
            numeric_NumNations.Visible = False
            cmb_Regions.Visible = True
            cmb_Province.Visible = True
            cmb_DataType.Visible = True
            chk_LockScales.Visible = False
        End If
        Refresh()
    End Sub

    Private Function DataOriginIsCharNations() As Boolean
        If SelectedDataOrigin = DataOrigin.Confirmed_and_Deaths Or _
               SelectedDataOrigin = DataOrigin.Confirmed_and_Incr Or _
               SelectedDataOrigin = DataOrigin.Deaths_and_Increments Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub cmb_DataOrigin_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_DataOrigin.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        chk_LockScales.Checked = False
        SelectedDataOrigin = CType(cmb_DataOrigin.SelectedIndex, DataOrigin)
        LoadData()
        ChartDay = 0
        ChartDayInteger = 0
        Chart1.DeselectRegion()
        DecodeData()
        ShowHideControls()
    End Sub

    Private Sub cmb_Regions_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Regions.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        SelectedRegion = cmb_Regions.Text
        If Not DataTypeIsChart() Then
            If SelectedDataOrigin = DataOrigin.Nations Then
                Select Case SelectedDataType
                    Case "Confirmed" : DecodeNationSecondNames(LinesGlobalConfirmed)
                    Case "Deaths" : DecodeNationSecondNames(LinesGlobalDeaths)
                    Case "Recovered" : DecodeNationSecondNames(LinesGlobalRecovered)
                End Select
            Else
                DecodeProvinceNames()
            End If
        End If
        DecodeData()
    End Sub
    Private Sub cmb_Province_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Province.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        SelectedProvincia = cmb_Province.Text
        DecodeData()
    End Sub
    Private Sub cmb_DataType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_DataType.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        SelectedDataType = cmb_DataType.Text
        LoadData()
        DecodeData()
    End Sub

    Private Sub gbox_DataList_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles gbox_DataList.Click
        If DataTypeIsChart() Then Return
        SplitContainer1.SplitterDistance = 9999
    End Sub
    Private Sub gbox_Graph_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles gbox_Graph.Click
        If DataTypeIsChart() Then Return
        SplitContainer1.SplitterDistance = 0
    End Sub


    ' ===================================================================================
    '  LOAD DATA
    ' ===================================================================================
    Private Sub LoadData()
        ' ---------------------------------------------------- cmb_DataOrigin and SelectedDataOrigin
        EventsAreEnabled = False
        cmb_DataOrigin.Text = SelectedDataOrigin.ToString.Replace("_", " ")
        If cmb_DataOrigin.Text = "" Then
            cmb_DataOrigin.SelectedIndex = 2
            SelectedDataOrigin = CType(cmb_DataOrigin.SelectedIndex, DataOrigin)
        End If
        EventsAreEnabled = True
        ' ----------------------------------------------------
        If DataTypeIsChart() Then Return
        ' ----------------------------------------------------
        If SelectedDataOrigin < DataOrigin.Italia Then
            LoadDataWorld()
        Else
            LoadDataItaly()
        End If
    End Sub

    ' ===================================================================================
    '  LOAD DATA WORLD
    ' ===================================================================================
    Private Sub LoadDataWorld()
        ' ---------------------------------------------------- add to combo box
        cmb_DataType.Items.Clear()
        cmb_DataType.Items.Add("Confirmed")
        cmb_DataType.Items.Add("Deaths")
        cmb_DataType.Items.Add("Recovered")
        ' ---------------------------------------------------- select datatype or a default datatype
        EventsAreEnabled = False
        cmb_DataType.Text = SelectedDataType
        If cmb_DataType.Text = "" AndAlso cmb_DataType.Items.Count > 0 Then
            cmb_DataType.SelectedIndex = 0
            SelectedDataType = cmb_DataType.Text
        End If
        EventsAreEnabled = True
        '
        If chk_OriginalData.Checked Then
            Select Case SelectedDataType
                Case "Confirmed" : txt_DataList.Text = StrRawDataConfirmed
                Case "Deaths" : txt_DataList.Text = StrRawDataDeaths
                Case "Recovered" : txt_DataList.Text = StrRawDataRecovered
            End Select
        End If
        '
        cmb_Regions.Enabled = True
        cmb_Province.Enabled = True
        '
        Select Case SelectedDataType
            Case "Confirmed"
                DecodeNationNames(LinesGlobalConfirmed)
                DecodeNationSecondNames(LinesGlobalConfirmed)
            Case "Deaths"
                DecodeNationNames(LinesGlobalDeaths)
                DecodeNationSecondNames(LinesGlobalDeaths)
            Case "Recovered"
                DecodeNationNames(LinesGlobalRecovered)
                DecodeNationSecondNames(LinesGlobalRecovered)
        End Select
    End Sub

    ' ===================================================================================
    '  LOAD DATA ITALY
    ' ===================================================================================
    Private Sub LoadDataItaly()
        ' -----------------------------------------------------
        If chk_OriginalData.Checked Then
            Select Case SelectedDataOrigin
                Case DataOrigin.Italia : txt_DataList.Text = StrRawDataItalia
                Case DataOrigin.Regioni : txt_DataList.Text = StrRawDataRegioni
                Case DataOrigin.Province : txt_DataList.Text = StrRawDataProvince
            End Select
        End If
        ' -----------------------------------------------------
        Select Case SelectedDataOrigin
            Case DataOrigin.Italia
                cmb_Regions.Enabled = False
                cmb_Province.Enabled = False
                cmb_Regions.Items.Clear()
                cmb_Province.Items.Clear()
                SelectedRegion = ""
                SelectedProvincia = ""
                FirstDataType = 2
                LastDataType = 13
                DecodeDataTypes()
            Case DataOrigin.Regioni
                cmb_Regions.Enabled = True
                cmb_Province.Enabled = False
                cmb_Province.Items.Clear()
                SelectedProvincia = ""
                DecodeRegionNames()
                FirstDataType = 6
                LastDataType = 17
                DecodeDataTypes()
            Case DataOrigin.Province
                cmb_Regions.Enabled = True
                cmb_Province.Enabled = True
                DecodeRegionNames()
                DecodeProvinceNames()
                FirstDataType = 9
                LastDataType = 9
                DecodeDataTypes()
        End Select
    End Sub

    ' ===================================================================================
    '  Sum NationData
    ' ===================================================================================
    Private Sub SortNationLines(ByRef lines() As String)
        ' ----------------------------------------------------- Replace Comma Inside Quotes
        For i As Int32 = 0 To lines.Length - 1
            lines(i) = ReplaceCommaInsideQuotes(lines(i))
        Next
        ' ----------------------------------------------------- save firstline and sort
        Dim firstLine As String = lines(0)
        lines(0) = "AAAAAAAAAAAA,AAAAAAAAAAAA,AAAAAAAAAAAA"
        SortLinesArray_ByField_1(lines)
        lines(0) = firstLine
    End Sub

    Private Sub SumNationData(ByRef lines() As String)
        Dim sa(-1) As String
        Dim sa2(-1) As String
        Dim LastLine As Int32 = lines.Length - 1
        For i As Int32 = 1 To LastLine
            lines(i) = ReplaceCommaInsideQuotes(lines(i))
            sa = lines(i).Split(","c)
            If sa.Length > 3 Then
                Dim Name As String = sa(1)
                Dim SubName As String = sa(0)
                Dim Latit As String = sa(2)
                Dim Longit As String = sa(3)
                If Name <> SubName Then
                    Dim sums(sa.Length) As Int32
                    For j As Int32 = i To lines.Length - 1
                        sa2 = lines(j).Split(","c)
                        If sa2.Length > 3 Then
                            If Name = sa2(1) Then
                                For k As Int32 = 4 To sa2.Length - 1
                                    sums(k) += CInt(Val(sa2(k)))
                                Next
                            Else
                                i = j - 1
                                Exit For
                            End If
                        End If
                    Next
                    '
                    Dim newLine As String = Name + "," + Name + "," + Latit + "," + Longit
                    For k As Int32 = 4 To sa.Length - 1
                        newLine += "," + sums(k).ToString
                    Next
                    ReDim Preserve lines(lines.Length)
                    lines(lines.Length - 1) = newLine
                End If
            End If
        Next
    End Sub

    ' ===================================================================================
    '  DECODE NationNames / RegionNames / ProvinceNames / DataTypes
    ' ===================================================================================
    Private AlphabeticOrder As Boolean = False

    Private Sub DecodeNationNames(ByRef lines() As String)
        ' ---------------------------------------------------- regions to list
        Dim s As String
        Dim sa() As String
        Dim Regions As List(Of String) = New List(Of String)
        For i As Int32 = 1 To lines.Length - 1
            sa = lines(i).Split(","c)
            If sa.Length > 1 Then
                If sa(0) = sa(1) Then
                    If AlphabeticOrder Then
                        s = sa(1)
                    Else
                        s = Math.Abs(Val(sa(sa.Length - 1))).ToString("00000000000") + "  " + sa(1)
                    End If
                    If Not Regions.Contains(s) Then
                        Regions.Add(s)
                    End If
                End If
            End If
        Next
        ' ---------------------------------------------------- sort the list
        Regions.Sort()
        If Not AlphabeticOrder Then Regions.Reverse()
        ' ---------------------------------------------------- add to combo box
        cmb_Regions.Items.Clear()
        For Each s In Regions
            If s.StartsWith("00") Then
                cmb_Regions.Items.Add(s.Substring(13))
            Else
                cmb_Regions.Items.Add(s)
            End If
        Next
        ' ---------------------------------------------------- 
        EventsAreEnabled = False
        cmb_Regions.Text = SelectedRegion
        If cmb_Regions.Text = "" AndAlso cmb_Regions.Items.Count > 0 Then
            cmb_Regions.SelectedIndex = 0
        End If
        SelectedRegion = cmb_Regions.Text
        EventsAreEnabled = True
    End Sub

    Private Sub DecodeNationSecondNames(ByRef lines() As String)
        ' ---------------------------------------------------- second-names to list
        Dim s As String
        Dim sa() As String
        Dim SecondNames As List(Of String) = New List(Of String)
        For i As Int32 = 1 To lines.Length - 1
            lines(i) = ReplaceCommaInsideQuotes(lines(i))
            sa = lines(i).Split(","c)
            s = sa(0)
            If sa.Length > 1 Then
                If s <> "" AndAlso sa(1) = SelectedRegion Then

                    If sa(0) = sa(1) Then
                        s = "AAAAAAAA" + s
                    End If

                    If Not SecondNames.Contains(s) Then
                        SecondNames.Add(s)
                    End If
                End If
            End If
        Next
        ' ---------------------------------------------------- exit if only one region
        If SecondNames.Count = 1 Then
            SelectedProvincia = SelectedRegion
            cmb_Province.Items.Clear()
            cmb_Province.Enabled = False
            Return
        End If
        ' ---------------------------------------------------- sort the list
        SecondNames.Sort()
        ' ---------------------------------------------------- add to combo box
        cmb_Province.Enabled = True
        cmb_Province.Items.Clear()
        For Each s In SecondNames
            cmb_Province.Items.Add(s.Replace("AAAAAAAA", ""))
        Next
        ' ---------------------------------------------------- 
        EventsAreEnabled = False
        cmb_Province.Text = SelectedProvincia
        If cmb_Province.Text = "" AndAlso cmb_Province.Items.Count > 0 Then
            cmb_Province.SelectedIndex = 0
        End If
        SelectedProvincia = cmb_Province.Text
        EventsAreEnabled = True
    End Sub

    Private Sub DecodeRegionNames()
        ' ---------------------------------------------------- test if valid
        If Not SelectedDataOrigin = DataOrigin.Regioni And _
           Not SelectedDataOrigin = DataOrigin.Province Then
            Return
        End If
        ' ---------------------------------------------------- regions to list
        Dim s As String
        Dim sa() As String
        Dim Regions As List(Of String) = New List(Of String)
        For i As Int32 = 1 To LinesRegioni.Length - 1
            sa = LinesRegioni(i).Split(","c)
            If sa.Length > 10 Then
                s = sa(2) + " " + sa(3)
                If Not Regions.Contains(s) Then
                    Regions.Add(s)
                End If
            End If
        Next
        ' ---------------------------------------------------- sort the list
        Regions.Sort()
        ' ---------------------------------------------------- add to combo box
        cmb_Regions.Items.Clear()
        For Each s In Regions
            cmb_Regions.Items.Add(s.Substring(3))
        Next
        ' ----------------------------------------------------
        EventsAreEnabled = False
        cmb_Regions.Text = SelectedRegion
        If cmb_Regions.Text = "" AndAlso cmb_Regions.Items.Count > 0 Then
            cmb_Regions.SelectedIndex = 0
        End If
        SelectedRegion = cmb_Regions.Text
        EventsAreEnabled = True
    End Sub

    Private Sub DecodeProvinceNames()
        ' ---------------------------------------------------- test if valid
        If Not SelectedDataOrigin = DataOrigin.Province Then
            Return
        End If
        ' ---------------------------------------------------- regions to list
        Dim s As String
        Dim sa() As String
        Dim Province As List(Of String) = New List(Of String)
        For i As Int32 = 1 To LinesProvince.Length - 1
            sa = LinesProvince(i).Split(","c)
            If sa.Length > 10 Then
                If sa(3) = SelectedRegion Then
                    s = sa(4) + " " + sa(5)
                    If Not Province.Contains(s) Then
                        Province.Add(s)
                    End If
                End If
            End If
        Next
        ' ---------------------------------------------------- sort the list
        Province.Sort()
        ' ---------------------------------------------------- add to combo box
        cmb_Province.Items.Clear()
        For Each s In Province
            cmb_Province.Items.Add(s.Substring(4))
        Next
        ' ---------------------------------------------------- 
        EventsAreEnabled = False
        cmb_Province.Text = SelectedProvincia
        If cmb_Province.Text = "" AndAlso cmb_Province.Items.Count > 0 Then
            cmb_Province.SelectedIndex = 0
        End If
        SelectedProvincia = cmb_Province.Text
        EventsAreEnabled = True
    End Sub

    Private FirstDataType As Int32
    Private LastDataType As Int32
    Private Sub DecodeDataTypes()
        Dim s As String
        Dim sa() As String = {""}
        Select Case SelectedDataOrigin
            Case DataOrigin.Italia : sa = LinesItalia(0).Split(","c)
            Case DataOrigin.Regioni : sa = LinesRegioni(0).Split(","c)
            Case DataOrigin.Province : sa = LinesProvince(0).Split(","c)
        End Select
        ' ---------------------------------------------------- limit first and last
        If FirstDataType < 0 Then FirstDataType = 0
        If FirstDataType > sa.Length - 1 Then FirstDataType = sa.Length - 1
        If LastDataType < FirstDataType Then LastDataType = FirstDataType
        If LastDataType > sa.Length - 1 Then LastDataType = sa.Length - 1
        ' ---------------------------------------------------- datatypes to list
        Dim DataTypes As List(Of String) = New List(Of String)
        For i As Int32 = FirstDataType To LastDataType
            s = sa(i)
            If s = "nuovi_positivi" Then Continue For
            If s = "variazione_totale_positivi" Then Continue For
            s = UpperCaseInitial(s)
            If Not DataTypes.Contains(s) Then
                DataTypes.Add(s)
            End If
        Next
        ' ---------------------------------------------------- sort the list
        'DataTypes.Sort()
        ' ---------------------------------------------------- add to combo box
        cmb_DataType.Items.Clear()
        For Each s In DataTypes
            cmb_DataType.Items.Add(s)
        Next
        ' ---------------------------------------------------- 
        EventsAreEnabled = False
        cmb_DataType.Text = SelectedDataType
        If cmb_DataType.Text = "" Then cmb_DataType.Text = "Totale casi"
        If cmb_DataType.Text = "" AndAlso cmb_DataType.Items.Count > 0 Then
            cmb_DataType.SelectedIndex = 0
        End If
        SelectedDataType = cmb_DataType.Text
        EventsAreEnabled = True
    End Sub

    Private Function DataTypeIsChart() As Boolean
        Select Case SelectedDataOrigin
            Case DataOrigin.Nations, DataOrigin.Italia, DataOrigin.Regioni, DataOrigin.Province
                Return False
            Case DataOrigin.Confirmed_and_Deaths, DataOrigin.Confirmed_and_Incr, DataOrigin.Deaths_and_Increments, DataOrigin.Casi_e_Decessi, DataOrigin.Casi_e_Incrementi, DataOrigin.Decessi_e_Incrementi
                Return True
        End Select
    End Function

    ' ===================================================================================
    '  DECODE DATA
    ' ===================================================================================
    Private Sub DecodeData(Optional ByVal InitChartScales As Boolean = True)
        '
        If SelectedDataType Is Nothing Then Return
        '
        If DataTypeIsChart() Then
            SplitContainer1.Panel1Collapsed = True
            Refresh()
            If SelectedDataOrigin < DataOrigin.Italia Then
                If LinesGlobalConfirmed Is Nothing OrElse LinesGlobalConfirmed.Length < 2 Then Return
                If LinesGlobalDeaths Is Nothing OrElse LinesGlobalDeaths.Length < 2 Then Return
                If LinesGlobalRecovered Is Nothing OrElse LinesGlobalRecovered.Length < 2 Then Return
                DecodeChartNations(InitChartScales)
            Else
                If LinesItalia Is Nothing Or LinesRegioni Is Nothing Or LinesProvince Is Nothing Then Return
                If LinesItalia.Length < 2 Or LinesRegioni.Length < 2 Or LinesProvince.Length < 2 Then Return
                DecodeChartItaly(InitChartScales)
            End If
            Refresh()
        Else
            SplitContainer1.Panel1Collapsed = False
            Refresh()
            If SelectedDataOrigin = DataOrigin.Nations Then
                If LinesGlobalConfirmed Is Nothing OrElse LinesGlobalConfirmed.Length < 2 Then Return
                If LinesGlobalDeaths Is Nothing OrElse LinesGlobalDeaths.Length < 2 Then Return
                If LinesGlobalRecovered Is Nothing OrElse LinesGlobalRecovered.Length < 2 Then Return
                DecodeDataNations()
            Else
                If LinesItalia Is Nothing Or LinesRegioni Is Nothing Or LinesProvince Is Nothing Then Return
                If LinesItalia.Length < 2 Or LinesRegioni.Length < 2 Or LinesProvince.Length < 2 Then Return
                DecodeDataItaly()
            End If
            Refresh()
        End If
    End Sub


    ' ===================================================================================
    '  DECODE DATA NATIONS
    ' ===================================================================================
    Private Sub DecodeDataNations()
        Dim incrSmooth As Double = Double.MaxValue
        Dim DateString As String
        Dim RegionString As String
        Dim ValueOld As Double
        Dim ValueNew As Double
        Dim Incr As Double
        Dim IncrString As String
        Dim IncrPerc As Double
        Dim IncrPercString As String
        '
        gbox_Graph.Text = "Graph"
        '
        If Not chk_OriginalData.Checked Then
            txt_DataList.Text = ""
        End If
        DataArray1.Flush()
        '
        ' ---------------------------------------------------- extract lines by SelectedRegion and SelectedProvincia
        Dim LineConfirmed As String = GetGlobalLine(LinesGlobalConfirmed)
        Dim LineDeaths As String = GetGlobalLine(LinesGlobalDeaths)
        Dim LineRecovered As String = GetGlobalLine(LinesGlobalRecovered)

        Dim saConfirmed() As String = LineConfirmed.Split(","c)
        Dim saDeaths() As String = LineDeaths.Split(","c)
        Dim saRecovered() As String = LineRecovered.Split(","c)
        '
        ' ----------------------------------------------------
        Dim sa() As String = {"", ""}
        Select Case SelectedDataType
            Case "Confirmed" : sa = saConfirmed
            Case "Deaths" : sa = saDeaths
            Case "Recovered" : sa = saRecovered
        End Select

        '------------------------------------- REGION
        If SelectedProvincia <> "" And sa(1) <> sa(0) Then
            RegionString = sa(1) + "  " + sa(0)
        Else
            RegionString = sa(1)
        End If
        '
        For j As Int32 = 5 To sa.Length - 1
            ' -------------------------------------------- DATE
            DateString = LinesGlobalConfirmed(0).Split(","c)(j)
            Dim ItemDate As Date = ConvertToDate(DateString)
            '
            ' -------------------------------------------- VALUE / INCREMENT / PERCENTUAL
            ValueNew = Val(sa(j))
            Incr = ValueNew - ValueOld
            IncrString = Incr.ToString("+0;-0", GCI)
            IncrPerc = 100 * (ValueNew / ValueOld - 1)
            IncrPercString = "(" + IncrPerc.ToString("+0.00;-0.00", GCI) + "%)"
            ValueOld = ValueNew
            ' -------------------------------------------- Death Percentual
            Dim DeathPercentualString As String = ""
            Dim DeathPercentual As Double
            DeathPercentual = Val(saDeaths(j)) * 100 / Val(saConfirmed(j))
            DeathPercentualString = "   Deaths versus total cases: " + _
                                    DeathPercentual.ToString("0.0", GCI) + "%"
            ' -------------------------------------------- text data
            If Not chk_OriginalData.Checked Then
                txt_DataList.Text += ItemDate.ToString("yyyy-MM-dd") + "  " + _
                                     RegionString + "  " + _
                                     SelectedDataType + ":" + _
                                     ValueNew.ToString("0").PadLeft(8) + _
                                      "    Variation:" + IncrString.PadLeft(8) + _
                                     IncrPercString.PadLeft(11) + _
                                     DeathPercentualString + vbCrLf
            End If
            ' -------------------------------------------- increment smoothed 
            If incrSmooth = Double.MaxValue Then incrSmooth = Incr
            incrSmooth += (Incr - incrSmooth) / 3
            'If incrSmooth < 0.01 Then incrSmooth = 0.01
            ' -------------------------------------------- fill data array
            DataArray1.AddElement(ValueNew, _
                                  incrSmooth, _
                                  DeathPercentual, _
                                  ItemDate)
        Next



        ' ---------------------------------------- remove last LineFeed
        txt_DataList.Text = RemoveLastLineFeed(txt_DataList.Text)
        ' ---------------------------------------- ensure visible and scroll to caret
        Me.Show()
        txt_DataList.SelectionStart = 999999
        txt_DataList.ScrollToCaret()
        ' ---------------------------------------- update graph
        GraphPaper1.LanguageIsEnglish = True
        GraphPaper1.UpdateTimeGraph()
        pbox_Graph.Refresh()
    End Sub

    Private Function GetGlobalLine(ByVal lines() As String) As String
        Dim sa() As String
        For i As Int32 = 1 To lines.Length - 1
            sa = lines(i).Split(","c)
            If sa.Length >= 3 Then
                If SelectedRegion <> "" AndAlso sa(1) <> SelectedRegion Then
                    Continue For
                End If
                If SelectedProvincia <> "" AndAlso sa(0) <> SelectedProvincia Then
                    Continue For
                End If
                Return lines(i)
            End If
        Next
        Return ""
    End Function

    Private Function ConvertToDate(ByVal datestring As String) As Date
        Dim year, month, day As Int32
        Dim da() As String = datestring.Split("/"c)
        If da.Length = 3 Then
            year = CInt(Val("20" + da(2)))
            month = CInt(Val(da(0)))
            day = CInt(Val(da(1)))
        End If
        Return New Date(year, month, day)
    End Function


    ' ===================================================================================
    '  DECODE DATA ITALY
    ' ===================================================================================
    Private Sub DecodeDataItaly()
        Dim incrSmooth As Double = Double.MaxValue
        Dim DateString As String
        Dim RegionString As String
        Dim ValueOld As Double
        Dim ValueNew As Double
        Dim Incr As Double
        Dim IncrString As String
        Dim IncrPerc As Double
        Dim IncrPercString As String
        Dim sa() As String
        Dim lines() As String = {""}
        '
        gbox_Graph.Text = "Grafico"
        '
        Select Case SelectedDataOrigin
            Case DataOrigin.Italia : lines = LinesItalia
            Case DataOrigin.Regioni : lines = LinesRegioni
            Case DataOrigin.Province : lines = LinesProvince
        End Select
        '
        Dim TotalCasesIndex As Int32 = FindIndex(lines(0), "totale_casi")
        Dim DeathIndex As Int32 = FindIndex(lines(0), "deceduti")
        Dim DataTypeIndex As Int32 = FindIndex(lines(0), SelectedDataType.Replace(" ", "_").ToLower)
        '
        If Not chk_OriginalData.Checked Then
            txt_DataList.Text = ""
        End If
        DataArray1.Flush()
        ' ----------------------------------------------------
        For i As Int32 = 1 To lines.Length - 1
            sa = lines(i).Split(","c)
            If sa.Length >= 5 AndAlso sa.Length >= DataTypeIndex Then
                ' -------------------------------------------- 
                If SelectedRegion <> "" AndAlso sa(3) <> SelectedRegion Then
                    Continue For
                End If
                If SelectedProvincia <> "" AndAlso sa(5) <> SelectedProvincia Then
                    Continue For
                End If
                ' -------------------------------------------- DATE
                DateString = Strings.Left(sa(0), 10)
                ' -------------------------------------------- REGION
                If SelectedProvincia <> "" Then
                    RegionString = sa(3) + "  " + sa(5)
                ElseIf SelectedRegion <> "" Then
                    RegionString = sa(3)
                Else
                    RegionString = "Italia"
                End If
                ' -------------------------------------------- VALUE / INCREMENT / PERCENTUAL
                ValueNew = Val(sa(DataTypeIndex))
                Incr = ValueNew - ValueOld
                IncrString = Incr.ToString("+0;-0", GCI)
                IncrPerc = 100 * (ValueNew / ValueOld - 1)
                IncrPercString = "(" + IncrPerc.ToString("+0.00;-0.00", GCI) + "%)"
                ValueOld = ValueNew
                ' -------------------------------------------- Death Percentual
                Dim DeathPercentualString As String = ""
                Dim DeathPercentual As Double
                If SelectedDataOrigin <> DataOrigin.Province Then
                    DeathPercentual = Val(sa(DeathIndex)) * 100 / Val(sa(TotalCasesIndex))
                    DeathPercentualString = "   Decessi su totale casi: " + _
                                            DeathPercentual.ToString("0.0", GCI) + "%"
                End If
                ' -------------------------------------------- text data
                If Not chk_OriginalData.Checked Then
                    txt_DataList.Text += DateString + " " + _
                                         RegionString + " " + _
                                         SelectedDataType + ":" + _
                                         ValueNew.ToString("0").PadLeft(7) + _
                                         "   Variazione:" + IncrString.PadLeft(8) + _
                                         IncrPercString.PadLeft(11) + _
                                         DeathPercentualString + vbCrLf
                End If
                ' -------------------------------------------- increment smoothed 
                If incrSmooth = Double.MaxValue Then incrSmooth = Incr
                incrSmooth += (Incr - incrSmooth) / 3
                'If incrSmooth < 0.01 Then incrSmooth = 0.01
                ' -------------------------------------------- fill data array
                DataArray1.AddElement(ValueNew, _
                                      incrSmooth, _
                                      DeathPercentual, _
                                      Date.Parse(DateString))
            End If
        Next
        ' ---------------------------------------- remove last LineFeed
        txt_DataList.Text = RemoveLastLineFeed(txt_DataList.Text)
        ' ---------------------------------------- ensure visible and scroll to caret
        Me.Show()
        txt_DataList.SelectionStart = 999999
        txt_DataList.ScrollToCaret()
        ' ---------------------------------------- update graph
        GraphPaper1.LanguageIsEnglish = False
        GraphPaper1.UpdateTimeGraph()
        pbox_Graph.Refresh()
    End Sub


    ' ===================================================================================
    '  DECODE CHART NATIONS
    ' ===================================================================================
    Private Sub DecodeChartNations(ByVal InitChartScales As Boolean)
        '
        Static TraceDays As Int32
        '
        If InitChartScales Then
            gbox_Graph.Text = "Graph"
            chk_LockScales.Text = "Lock scale"
            chk_LockScales.Left = gbox_Graph.ClientSize.Width - chk_LockScales.Width - 12
            Select Case SelectedDataOrigin
                Case DataOrigin.Confirmed_and_Deaths
                    Chart1.Ylog = False
                    Chart1.Ymin = 0
                    Chart1.Ymax = 20
                    Chart1.Ypercent = "%"
                    Chart1.Ycaption = "Deaths percentual over total cases"
                    Chart1.Xlog = False
                    Chart1.Xmin = 0
                    Chart1.Xmax = 6
                    Chart1.Xstep = 1
                    Chart1.Xpercent = ""
                    Chart1.Xcaption = "Cases for every thousand inhabitants"
                    TraceDays = 15
                Case DataOrigin.Confirmed_and_Incr
                    Chart1.Ylog = True
                    Chart1.Ymin = 0
                    Chart1.Ymax = 35
                    Chart1.Ypercent = "%"
                    Chart1.Ycaption = "Percentage increase in the last week"
                    Chart1.Xlog = False
                    Chart1.Xmin = 0
                    Chart1.Xmax = 6
                    Chart1.Xstep = 1
                    Chart1.Xpercent = ""
                    Chart1.Xcaption = "Cases for every thousand inhabitants"
                    TraceDays = 15
                Case DataOrigin.Deaths_and_Increments
                    Chart1.Ylog = True
                    Chart1.Ymin = 0
                    Chart1.Ymax = 35
                    Chart1.Ystep = 5
                    Chart1.Ypercent = "%"
                    Chart1.Ycaption = "Percentage increase in the last week"
                    Chart1.Xlog = False
                    Chart1.Xmin = 0
                    Chart1.Xmax = 20
                    Chart1.Xpercent = "%"
                    Chart1.Xcaption = "Deaths percentual over total cases"
                    TraceDays = 15
            End Select
            '
            ChartDay = 0
        End If
        '
        Dim sa() As String
        sa = LinesGlobalConfirmed(0).Split(","c)
        ' ---------------------------------------------------------------- limit ChartDay
        If ChartDayInteger < -sa.Length + 26 Then
            ChartDayInteger = -sa.Length + 26
            ChartDay = ChartDayInteger
        End If
        ' ---------------------------------------------------------------- print ChartDay
        Dim DateString As String = sa(sa.Length - 1)
        Dim Date_ As Date = ConvertToDate(DateString).AddDays(ChartDayInteger)
        Chart1.DayCaption = Date_.ToString("dd MMM yyyy")
        ' ---------------------------------------------------------------- fill the chart
        ChartArray1.ClearAll()
        '
        Dim ChartDayFinal As Int32 = ChartDayInteger
        For i As Int32 = -TraceDays To 0
            ChartDayInteger = ChartDayFinal + i
            FillChartWORLD(i)
        Next
        '
        Chart1.UpdateChart()
        pbox_Graph.Refresh()
    End Sub

    Private Sub FillChartWORLD(ByVal TraceDay As Int32)
        Dim sa() As String
        For i As Int32 = 0 To CInt(numeric_NumNations.Value) - 1
            sa = NationLinesConfirmedSorted(i).Split(","c)
            ' -------------------------------------------------------------------------------
            Dim Name As String = sa(1)
            If DisabledNations.Contains(Name) Then Continue For
            ' -------------------------------------------------------------------------------
            Dim Casi As Single = CSng(Val(sa(sa.Length - 1 + ChartDayInteger)))
            Dim CasiSuAbitanti As Single = CSng(1000 * Casi / Abitanti(sa(1)))
            Dim CasiSetteGiorni As Single = CSng(Val(sa(sa.Length - 8 + ChartDayInteger)))
            ' -------------------------------------------------------------------------------
            Dim line As String = GetNationLineByName(NationLinesDeathsSorted, sa(1))
            sa = line.Split(","c)
            Dim PercentualeDecessi As Single = CSng(100 * Val(sa(sa.Length - 1 + ChartDayInteger)) / Casi)
            ' -------------------------------------------------------------------------------
            Select Case SelectedDataOrigin
                Case DataOrigin.Confirmed_and_Deaths
                    ChartArray1.AddItem(Name, CasiSuAbitanti, PercentualeDecessi, TraceDay)
                Case DataOrigin.Confirmed_and_Incr
                    Dim PercentualeIncremento As Single = 100 * (Casi / CasiSetteGiorni - 1)
                    ChartArray1.AddItem(Name, CasiSuAbitanti, PercentualeIncremento, TraceDay)
                Case DataOrigin.Deaths_and_Increments
                    Dim PercentualeIncremento As Single = 100 * (Casi / CasiSetteGiorni - 1)
                    ChartArray1.AddItem(Name, PercentualeDecessi, PercentualeIncremento, TraceDay)
            End Select
        Next
    End Sub

    Private Function GetNationLinesSorted(ByRef lines() As String) As List(Of String)
        Dim s As String
        Dim sa() As String
        Dim NationLines As List(Of String) = New List(Of String)
        For i As Int32 = 1 To lines.Length - 1
            sa = lines(i).Split(","c)
            If sa.Length > 1 Then
                If sa(0) = sa(1) Then
                    s = Math.Abs(Val(sa(sa.Length - 1))).ToString("00000000000") + "  " + lines(i)
                    If Not NationLines.Contains(s) Then
                        NationLines.Add(s)
                    End If
                End If
            End If
        Next
        ' ---------------------------------------------------- sort and return the list
        NationLines.Sort()
        NationLines.Reverse()
        Return NationLines
    End Function

    Private Function GetNationLineByName(ByRef lines As List(Of String), ByVal NationName As String) As String
        Dim sa() As String
        For i As Int32 = 0 To lines.Count - 1
            sa = lines(i).Split(","c)
            If sa.Length > 1 Then
                If NationName = sa(1) Then
                    Return lines(i)
                End If
            End If
        Next
        Return ""
    End Function


    ' ===================================================================================
    '  DECODE CHART ITALY
    ' ===================================================================================
    Private Sub DecodeChartItaly(ByVal InitChartScales As Boolean)
        '
        Static TraceDays As Int32
        '
        If InitChartScales Then
            gbox_Graph.Text = "Grafico"
            chk_LockScales.Text = "Blocca la scala"
            chk_LockScales.Left = gbox_Graph.ClientSize.Width - chk_LockScales.Width - 12
            Select Case SelectedDataOrigin
                Case DataOrigin.Casi_e_Decessi
                    Chart1.Ylog = False
                    Chart1.Ymin = 0
                    Chart1.Ymax = 20
                    Chart1.Ypercent = "%"
                    Chart1.Ycaption = "Percentuale di decessi sul totale dei casi"
                    Chart1.Xlog = False
                    Chart1.Xmin = 0
                    Chart1.Xmax = 10
                    Chart1.Xstep = 1
                    Chart1.Xpercent = ""
                    Chart1.Xcaption = "Casi per ogni mille abitanti"
                    TraceDays = 21
                Case DataOrigin.Casi_e_Incrementi
                    Chart1.Ylog = True
                    Chart1.Ymin = 0
                    Chart1.Ymax = 15
                    Chart1.Ypercent = "%"
                    Chart1.Ycaption = "Incremento percentuale nell'ultima settimana"
                    Chart1.Xmin = 0
                    Chart1.Xlog = False
                    Chart1.Xmax = 10
                    Chart1.Xstep = 1
                    Chart1.Xpercent = ""
                    Chart1.Xcaption = "Casi per ogni mille abitanti"
                    TraceDays = 8
                Case DataOrigin.Decessi_e_Incrementi
                    Chart1.Ylog = True
                    Chart1.Ymin = 0
                    Chart1.Ymax = 16
                    Chart1.Ystep = 5
                    Chart1.Ypercent = "%"
                    Chart1.Ycaption = "Incremento percentuale nell'ultima settimana"
                    Chart1.Xlog = False
                    Chart1.Xmin = 0
                    Chart1.Xmax = 20
                    Chart1.Xpercent = "%"
                    Chart1.Xcaption = "Percentuale di decessi sul totale dei casi"
                    TraceDays = 8
            End Select
            '
            ChartDay = 0
        End If
        ' --------------------------------------------------------------- limit ChartDay
        If ChartDayInteger < -(LinesRegioni.Length \ 21) + 8 Then
            ChartDayInteger = -(LinesRegioni.Length \ 21) + 8
            ChartDay = ChartDayInteger
        End If
        ' --------------------------------------------------------------- print ChartDay
        Dim sa() As String
        sa = LinesRegioni(LinesRegioni.Length - 2).Split(","c)
        Dim DateString As String = sa(0)
        Dim Date_ As Date = Date.Parse(Strings.Left(DateString, 10)).AddDays(ChartDayInteger)
        Chart1.DayCaption = Date_.ToString("dd MMM yyyy")
        '
        ChartArray1.ClearAll()
        '
        Dim ChartDayFinal As Int32 = ChartDayInteger
        For i As Int32 = -TraceDays To 0
            ChartDayInteger = ChartDayFinal + i
            FillChartITA(i)
        Next
        '
        Chart1.UpdateChart()
        pbox_Graph.Refresh()
    End Sub

    Private Sub FillChartITA(ByVal TraceDay As Int32)
        ' --------------------------------------------------------------- prepare StartDay
        Dim StartDay As Int32 = LinesRegioni.Length - 1 + ChartDayInteger * 21
        If StartDay < 21 Then Return
        '
        Dim sa() As String
        For i As Int32 = StartDay - 21 To StartDay - 1
            If LinesRegioni(i).Length > 10 Then
                sa = LinesRegioni(i).Split(","c)

                Dim Nome As String = sa(3)
                If DisabledItalianRegions.Contains(Nome) Then Continue For

                Dim Casi As Single = CSng(Val(sa(15)))
                Dim CasiSuAbitanti As Single = CSng(1000 * Casi / Abitanti(sa(3)))
                Dim PercentualeDecessi As Single = CSng(100 * Val(sa(14)) / Casi)

                Dim j As Int32 = i - 7 * 21
                If j > 0 Then

                    sa = LinesRegioni(j).Split(","c)
                    Dim CasiSetteGiorni As Single = CSng(Val(sa(15)))
                    Select Case SelectedDataOrigin
                        Case DataOrigin.Casi_e_Decessi
                            ChartArray1.AddItem(sa(3), CasiSuAbitanti, PercentualeDecessi, TraceDay)
                        Case DataOrigin.Casi_e_Incrementi
                            Dim PercentualeIncremento As Single = 100 * (Casi / CasiSetteGiorni - 1)
                            ChartArray1.AddItem(sa(3), CasiSuAbitanti, PercentualeIncremento, TraceDay)
                        Case DataOrigin.Decessi_e_Incrementi
                            Dim PercentualeIncremento As Single = 100 * (Casi / CasiSetteGiorni - 1)
                            ChartArray1.AddItem(sa(3), PercentualeDecessi, PercentualeIncremento, TraceDay)
                    End Select
                End If
            End If
        Next
    End Sub

End Class

