﻿
Module Module_Utils

    Friend Function DownloadStringFromURL(ByVal url As String) As String
        If url = "" Then Return ""
        Dim len As Int32
        Dim buffer(128) As Byte
        Dim wreq As Net.WebRequest = Net.WebRequest.Create(url)
        wreq.Timeout = 10000
        Cursor.Current = Cursors.WaitCursor
        Try
            Dim wres As Net.WebResponse = wreq.GetResponse()
            Dim stream As IO.Stream = wres.GetResponseStream()
            len = stream.Read(buffer, 0, 128)
            Dim strRes As New System.Text.StringBuilder("")
            While len <> 0
                strRes.Append(System.Text.Encoding.ASCII.GetString(buffer, 0, len))
                len = stream.Read(buffer, 0, 128)
            End While
            DownloadStringFromURL = strRes.ToString().Replace(vbLf, vbCrLf)
        Catch
            DownloadStringFromURL = ""
        End Try
        Cursor.Current = Cursors.Default
    End Function

    Friend Function ReplaceCommaInsideQuotes(ByVal str As String) As String
        Dim s As String = ""
        Dim InsideQuotes As Boolean = False
        For Each c As Char In str
            Select Case c
                Case """"c
                    InsideQuotes = Not InsideQuotes
                Case ","c
                    If InsideQuotes Then
                        s += " "
                    Else
                        s += ","
                    End If
                Case Else
                    s += c
            End Select
        Next
        Return s
    End Function

    Friend Function FindIndex(ByVal line As String, ByVal datatype As String) As Int32
        Dim sa() As String = line.Split(","c)
        For i As Int32 = 0 To sa.Length - 1
            If sa(i) = datatype Then
                Return i
            End If
        Next
    End Function

    Private TrimCharsLineFeed() As Char = New Char() {CChar(vbLf)}
    Friend Function RemoveLastLineFeed(ByVal str As String) As String
        Return str.TrimEnd(TrimCharsLineFeed)
    End Function

    ' =========================================================================================
    '  Sort LinesArray By Field 1
    ' =========================================================================================
    Friend Sub SortLinesArray_ByField_1(ByRef lines() As String)
        Array.Sort(lines, AddressOf SortLinesArray_ByField_1_Comparer)
    End Sub
    Private Function SortLinesArray_ByField_1_Comparer(ByVal x As String, ByVal y As String) As Integer
        Dim saX() As String = x.Split(","c)
        Dim saY() As String = y.Split(","c)
        If saX.Length < 2 Then Return -1
        If saY.Length < 2 Then Return -1
        If saX(1) = saY(1) Then
            Return 0
        ElseIf saX(1) > saY(1) Then
            Return 1
        Else
            Return -1
        End If
    End Function


    Friend Sub InitPictureboxImage(ByVal pbox As PictureBox)
        With pbox
            If .ClientSize.Width < 1 Or .ClientSize.Height < 1 Then Return
            If .Image Is Nothing OrElse .Image.Width <> .ClientSize.Width _
                                 OrElse .Image.Height <> .ClientSize.Height Then
                .Image = New Bitmap(.ClientRectangle.Width, _
                                    .ClientRectangle.Height, _
                                    Imaging.PixelFormat.Format24bppRgb)
            End If
        End With
    End Sub


    'Private Function ReplaceMultipleSpacesAndTabAndTrim(ByVal s As String) As String
    '    If s = "" Then Return s
    '    s = s.Replace(vbTab, " ")
    '    While s.Contains("  ")
    '        s = s.Replace("  ", " ")
    '    End While
    '    Return s.Trim
    'End Function


    ' ==========================================
    '  UpperCase Initial and no underscores
    ' ==========================================
    Friend Function UpperCaseInitial(ByVal s As String) As String
        s = s.Replace("_", " ")
        s = Strings.Left(s, 1).ToUpper() + Strings.Mid(s.ToLower(), 2)
        Return s
    End Function


    ' =========================================================================================
    '  POPULATION DATA
    ' =========================================================================================
    Private PopulationData As Generic.Dictionary(Of String, Single) = New Generic.Dictionary(Of String, Single)
    Friend Sub LoadPopulationData()
        PopulationData.Clear()
        Dim fname As String = Application.StartupPath + "\Population.txt"
        If My.Computer.FileSystem.FileExists(fname) Then
            Dim sa() As String = IO.File.ReadAllLines(fname)
            For Each s As String In sa
                Dim sa2() As String = s.Split(","c)
                If sa2.Length = 2 Then
                    PopulationData.Add(sa2(0).Trim.ToLower, CSng(Val(sa2(1).Trim)))
                End If
            Next
        End If
    End Sub

    Friend Function Abitanti(ByVal RegionName As String) As Single

        Dim n As Single
        If PopulationData.TryGetValue(RegionName.ToLower, n) Then
            Return n
        End If

        Select Case RegionName.ToLower
            Case "world" : Return 7800000000
            Case "europe" : Return 446824564
            Case "afghanistan" : Return 37172386
            Case "argentina" : Return 44494502
            Case "austria" : Return 8955102
            Case "bangladesh" : Return 161356039
            Case "belarus" : Return 9483499
            Case "belgium" : Return 11539328
            Case "bolivia" : Return 11353142
            Case "brazil" : Return 211049527
            Case "canada" : Return 37411047
            Case "chile" : Return 18952038
            Case "china" : Return 1433783686
            Case "colombia" : Return 49648685
            Case "denmark" : Return 5793636
            Case "dominican republic" : Return 10627165
            Case "ecuador" : Return 17373662
            Case "egypt" : Return 98423595
            Case "france" : Return 65129728
            Case "germany" : Return 83517045
            Case "india" : Return 1366417754
            Case "indonesia" : Return 267663435
            Case "iran" : Return 82913906
            Case "ireland" : Return 4882495
            Case "israel" : Return 8519377
            Case "italy" : Return 60100075
            Case "japan" : Return 126860301
            Case "kuwait" : Return 4137309
            Case "mexico" : Return 127575529
            Case "netherlands" : Return 17097130
            Case "pakistan" : Return 216565318
            Case "panama" : Return 4176873
            Case "peru" : Return 32510453
            Case "philippines" : Return 106651922
            Case "poland" : Return 37974750
            Case "portugal" : Return 10226187
            Case "qatar" : Return 2781677
            Case "romania" : Return 19466145
            Case "russia" : Return 145872256
            Case "saudi arabia" : Return 34268528
            Case "singapore" : Return 5804337
            Case "south africa" : Return 57779622
            Case "spain" : Return 46736776
            Case "sweden" : Return 10036379
            Case "switzerland" : Return 8591365
            Case "turkey" : Return 83429615
            Case "ukraine" : Return 44622516
            Case "united arab emirates" : Return 9630959
            Case "united kingdom" : Return 67530172
            Case "us" : Return 329064917

            Case "italia" : Return 60359546
            Case "abruzzo" : Return 1311580
            Case "basilicata" : Return 562869
            Case "calabria" : Return 1947131
            Case "campania" : Return 5801692
            Case "emilia-romagna" : Return 4459477
            Case "friuli venezia giulia" : Return 1215220
            Case "lazio" : Return 5879082
            Case "liguria" : Return 1550640
            Case "lombardia" : Return 10060574
            Case "marche" : Return 1525271
            Case "molise" : Return 305617
            Case "p.a. bolzano" : Return 533050
            Case "p.a. trento" : Return 541380
            Case "piemonte" : Return 4356406
            Case "puglia" : Return 4029053
            Case "sardegna" : Return 1639591
            Case "sicilia" : Return 4999891
            Case "toscana" : Return 3729641
            Case "umbria" : Return 882015
            Case "valle d'aosta" : Return 125666
            Case "veneto" : Return 4905854

                'Case Else : MessageBox.Show("Not found " + RegionName)
            Case Else : Return 100000000
        End Select
    End Function

End Module
